## libblkio 1.5.0

=== meson_options.txt ===
option('subproject-docs', type : 'feature', value : 'auto', description : 'Build docs when libblkio is used as a subproject')
option('subproject-examples', type : 'feature', value : 'auto', description : 'Build examples when libblkio is used as a subproject')
option('subproject-tests', type : 'feature', value : 'auto', description : 'Build tests when libblkio is used as a subproject')

=== debian/changelog ===
libblkio (1.5.0-5) unstable; urgency=medium

  * d/libblkio1.symbols: add more (optional) symbols, simplify patterns
    (Closes: #1118299)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 18 Oct 2025 09:07:16 +0300

libblkio (1.5.0-4) unstable; urgency=medium

  * make dpkg-gensymbols fail on symbols change,
    and list two internal symbols now exported by rustc
  * switch to rustix 1.x (Closes: #1110380)

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 15 Oct 2025 10:04:43 +0300

libblkio (1.5.0-3) unstable; urgency=medium

  * switch to io-uring 0.7 (Closes: #1112119)

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 26 Aug 2025 21:57:17 +0300

libblkio (1.5.0-2) unstable; urgency=medium

  * d/libblkio1.symbols: remove ARGV_INIT_ARRAY reference
    (not exported anymore by recent rust?)
    Closes: #1074719

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 02 Jul 2024 21:28:33 +0300

libblkio (1.5.0-1) unstable; urgency=medium

  * d/watch: adjust for current gitlab
  * new upstream release (packaging fixes)
  * remove patches which are applied upstream
  * d/libblkio1.symbols: work around rust exporting
    _ZN3std3sys4unix4args3imp15ARGV_INIT_ARRAY*@Base

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 12 May 2024 10:42:29 +0300

libblkio (1.4.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1030361)

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 08 May 2024 00:18:12 +0300

=== debian/control ===
Source: libblkio
Section: rust
Priority: optional
Build-Depends: debhelper-compat (= 13),
# rust-vmm crates are 64bit-only according to upstream
 architecture-is-64-bit,
 cargo:native,
 rustc:native,
 meson, ninja-build,
 python3-docutils,
 libstd-rust-dev,
 librust-cc-1-dev,
# Cargo.toml:
 librust-libc-0.2-dev,
# blkio/Cargo.toml:
 librust-bitflags-1-dev (>> 1.2),
 librust-paste-1-dev,
 librust-io-uring-0.7-dev,
 librust-lazy-static-1-dev (>= 1.1-~),
 librust-libc-0.2-dev,
 librust-pci-driver-0.1-dev (>= 0.1.2-~),
 librust-rustix-1-dev,
# virtio-driver/Cargo.toml:
 librust-bitflags-1-dev (>> 1.2),
 librust-libc-0.2-dev,
 librust-rustix-1-dev,
 librust-memmap2-0.9-dev,
 librust-pci-driver-0.1-dev (>= 0.1.2-~),
 librust-virtio-bindings-0.2-dev,
Maintainer: Michael Tokarev <mjt@tls.msk.ru>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/qemu-team/libblkio.git
Vcs-Browser: https://salsa.debian.org/qemu-team/libblkio/tree/master
Homepage: https://libblkio.gitlab.io/libblkio
Rules-Requires-Root: no

Package: libblkio1
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Block device I/O library (runtime files)
 libblkio is a library for high-performance block device I/O with support
 for multi-queue devices. A C API is provided so that applications can use
 the library from most programming languages.
 .
 This package provides the shared library for libblkio.

Package: libblkio-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libblkio1 (=${binary:Version}), ${misc:Depends}
Description: Block device I/O library (development files)
 libblkio is a library for high-performance block device I/O with support
 for multi-queue devices. A C API is provided so that applications can use
 the library from most programming languages.
 .
 This package provides the development files for libblkio.

=== debian/rules ===
#! /usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
include /usr/share/dpkg/pkg-info.mk
ifeq (${DEB_HOST_GNU_TYPE},)
# Fast version of dpkg/architecture.mk defining all vars in one go
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif

# CARGO_HOME *must* end with "/debian/cargo_home"
export CARGO_HOME=${CURDIR}/b/debian/cargo_home
export CARGO=/usr/share/cargo/bin/cargo

export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

V = $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,-v)

# libblkio build system wraps cargo in meson.

build   build-arch   build-indep \
install install-arch install-indep \
binary  binary-arch  binary-indep \
: %:
	dh $@

# /usr/share/cargo/bin/cargo wrapper is stupid and broken in many ways,
# and apparently needs huge work to fix. Instead of trying to fight all
# its issues, use it only when absolutely necessary: just to set up
# the system registry and build flags.
# The rest is done using regular cargo directly.
override_dh_auto_configure:
	DEB_CARGO_CRATE=${DEB_SOURCE}_${DEB_VERSION_UPSTREAM} \
	DEB_HOST_RUST_TYPE=${DEB_HOST_GNU_TYPE} DEB_HOST_GNU_TYPE=${DEB_HOST_GNU_TYPE} \
	${CARGO} prepare-debian b/cargo-registry --link-from-system $V

	meson setup b/ --wrap-mode=nodownload --buildtype=plain \
		--prefix=/usr --sysconfdir=/etc --localstatedir=/var \
		--libdir=/usr/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_build:
	meson compile -C b/ -v

override_dh_auto_test:
ifneq (,$(filter nocheck,${DEB_BUILD_OPTIONS}))
	meson test -C b/ \
		--suite generic --suite io_uring+parallel --suite examples
endif

b := libblkio.so.1
f := libblkio.so.${DEB_VERSION_UPSTREAM}
override_dh_auto_install:
	meson install -C b/ --destdir ${CURDIR}/debian/tmp

#	cd debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}; \
#	    patchelf --set-soname ${b} ${f}; \
#	    ln -sf ${f} ${b}; \
#	    ln -sf ${b} libblkio.so

# dwz: Allocatable section in libblkio.so.1.4.0 after non-allocatable ones
override_dh_dwz:

clean:
	dh_clean b/ Cargo.lock

=== debian/watch ===
version=4
opts="searchmode=plain" \
https://gitlab.com/libblkio/libblkio/tags?sort=updated_desc -/archive/v?\d[\d.]+/libblkio-@ANY_VERSION@@ARCHIVE_EXT@
